CREATE OR REPLACE PROCEDURE GERA_RATEIO_CONTA(
   P_IDENTRSAID  IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_CDFILIAL    IN RATCTPAGAR.CDFILIAL%TYPE,
   P_LANCAMENTO  IN RATCTPAGAR.NRLANCTONF%TYPE,
   P_NRSEQVENC   IN RATCTPAGAR.NRSEQVENPAG%TYPE,
   P_NRPARCELA   IN RATCTPAGAR.NRPARCELAPAG%TYPE,
   P_VRCONTA     IN CONTAPAGAR.VRATUAPAG%TYPE,
   P_CDTIPOCONTA IN CONTAPAGAR.CDTPCTPAGAR%TYPE,
   P_CDFILIRAT   IN RATCTPAGAR.CDFIRATCTPAG%TYPE)
AS
   V_CDCENTCUST   FILIAL.CDCENTCUST%TYPE;
   V_VALORRAT     RATCTPAGAR.VRRATCCCTPAG%TYPE;
   V_RATTPCT      NUMBER;
   V_CDFILIAL     FILIAL.CDFILIAL%TYPE;
   V_IDSISTEMA    NOTAFISCAL.IDSISTEMA%TYPE;
   V_CDEMPRESA    NOTAFISCAL.CDEMPRESA%TYPE;

   CURSOR C_RATTPCTPAG IS
      SELECT CDFILIAL, CDCENTCUST, CDFIRATTPCTP, VRPERATTPCTP
      FROM  RATTPCTP
      WHERE CDTPCTPAGAR = P_CDTIPOCONTA;

   CURSOR C_RATTPCTREC IS
      SELECT CDFILIAL, CDCENTCUST, CDFIRATTPCTR, VRPERATTPCTR
      FROM  RATTPCTR
      WHERE CDTPCTRECEB = P_CDTIPOCONTA;
      
   CURSOR C_TP_CONTA_RATEIO_PAG(P_CDFILIAL VARCHAR2,
                              P_NRLANCTONF VARCHAR2)
   IS
      SELECT PROD.CDTPCTPAGAR, PROD.CDFILIAL, PROD.NRLANCTONF, PROD.NRSEQITPROD
        FROM TIPOCTPAGAR TP,
             (SELECT P3.CDPRODUTO, P4.CDARVPROD, P4.CDTPCTPAGAR,
                     I.NRSEQITPROD, I.CDFILIAL, I.NRLANCTONF
               FROM ITEMPRODUTO I, PRODUTO P3, PRODUTO P4
              WHERE I.CDFILIAL = P_CDFILIAL
                AND I.NRLANCTONF = P_NRLANCTONF
                AND I.CDPRODUTO = P3.CDPRODUTO
                AND (INSTR(P3.CDARVPROD,NVL(RTRIM(P4.CDARVPROD),P3.CDARVPROD)) = 1)
                AND P4.CDTPCTPAGAR IS NOT NULL
                AND P4.CDARVPROD = (SELECT MAX(P1.CDARVPROD)
                                      FROM ITEMPRODUTO IT,  PRODUTO P, PRODUTO P1
                                     WHERE IT.CDFILIAL = I.CDFILIAL
                                       AND IT.NRLANCTONF = I.NRLANCTONF
                                       AND IT.CDPRODUTO = I.CDPRODUTO
                                       AND IT.CDPRODUTO = P.CDPRODUTO
                                       AND (INSTR(P.CDARVPROD,NVL(RTRIM(P1.CDARVPROD),P.CDARVPROD)) = 1)
                                       AND P1.CDTPCTPAGAR IS NOT NULL)
                AND NOT EXISTS (SELECT 1
                                  FROM NOTAFISCAL NF, TPOPERCFOP T
                                 WHERE NF.CDFILIAL     = P_CDFILIAL
                                   AND NF.NRLANCTONF   = P_NRLANCTONF
                                   AND NF.CDFILIAL     = I.CDFILIAL
                                   AND NF.NRLANCTONF   = I.NRLANCTONF
                                   AND I.CDFISOPEITEM  = T.CDFISCOPER
                                   AND NF.IDENTRSAIDOP = T.IDENTRSAIDOP
                                   AND NF.CDTIPOOPER   = T.CDTIPOOPER
                                   AND T.IDCOMPOEVENC  = 'N')
              ORDER BY P3.CDARVPROD) PROD
       WHERE PROD.CDTPCTPAGAR = TP.CDTPCTPAGAR;
   RECORD_TPCONTARATPAG C_TP_CONTA_RATEIO_PAG%ROWTYPE;      

   /*GERA RATEIO FINANCEIRO PARA AS CONTAS A PAGAR RELACIONADAS  NOTA FISCAL*/
   PROCEDURE GERA_RATEIO_PAG(P_CDEMPRESA IN VARCHAR2,
                             P_CDFILIORIG IN VARCHAR2,
                             P_CDFILIAL IN VARCHAR2,
                             P_NRLANCTONF IN VARCHAR2)
   IS
      V_NRPARCELA NUMBER;
      V_VRPARCELA NUMBER;
      V_VRACUMULADO NUMBER;
      V_CDFILIAL VARCHAR2(4);
      V_CDFILIRAT VARCHAR2(4);
      V_CDCENTCUST VARCHAR2(4);
      V_VRTOTCONTA NUMBER;
      V_CDTPCTRAT TIPOCTPAGAR.CDTPCTPAGAR%TYPE;
      V_TIPOCTDIFE VARCHAR(1);
      V_COUNT NUMBER;
      V_RATEIO_CDCENTCUSNF CENTCUST.CDCENTCUST%TYPE;
      V_RATEIO_CDFILICCUST FILIAL.CDFILIAL%TYPE;   
      V_RATPROD           VARCHAR2(1);      
      
      
   BEGIN
     /*APAGA, CASO EXISTA, OS RATEIOS DA CONTA A PAGAR DA NOTA FISCAL*/
      DELETE FROM RATCTPAGAR
       WHERE CDFILIAL = P_CDFILIAL
         AND NRLANCTONF = P_NRLANCTONF;
     /*PEGA O TIPO DE CONTA PARAMETRIZADO PARA CADAS PRODUTO DA NOTA E GRAVA NA TABELA RATEIONF*/
      OPEN C_TP_CONTA_RATEIO_PAG(P_CDFILIAL, P_NRLANCTONF);
      LOOP
          FETCH C_TP_CONTA_RATEIO_PAG INTO RECORD_TPCONTARATPAG;
          EXIT WHEN C_TP_CONTA_RATEIO_PAG%NOTFOUND;
         UPDATE RATEIONF
            SET CDTPCTPAGAR = RECORD_TPCONTARATPAG.CDTPCTPAGAR
          WHERE CDFILIAL    = RECORD_TPCONTARATPAG.CDFILIAL
            AND NRLANCTONF  = RECORD_TPCONTARATPAG.NRLANCTONF
            AND NRSEQITPROD = RECORD_TPCONTARATPAG.NRSEQITPROD;
      END LOOP;
      CLOSE C_TP_CONTA_RATEIO_PAG;
      FOR C_CTPAGRAT IN (SELECT DISTINCT CDTPCTPAGAR
                         FROM CONTAPAGAR
                        WHERE CDFILIAL = P_CDFILIAL
                          AND NRLANCTONF = P_NRLANCTONF) LOOP
         BEGIN
            SELECT MAX(CDTPCTPAGAR)
             INTO V_CDTPCTRAT
             FROM RATEIONF
            WHERE CDFILIAL    = P_CDFILIAL
              AND NRLANCTONF  = P_NRLANCTONF
              AND CDTPCTPAGAR = C_CTPAGRAT.CDTPCTPAGAR;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDTPCTRAT := NULL;
         END;
         IF (V_CDTPCTRAT IS NULL) THEN
            V_TIPOCTDIFE := 'S';
         END IF;
      END LOOP;
      /*BUSCA AS CONTAS RELACIONADAS  NOTA FISCAL E INSERE RATEIO PARA CADA UMA DELAS*/
      FOR C_CTPAG IN (SELECT CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG, CDTPCTPAGAR, VRATUAPAG, VRORIGPAG
                        FROM CONTAPAGAR
                       WHERE CDFILIAL = P_CDFILIAL
                         AND NRLANCTONF = P_NRLANCTONF) LOOP
         SELECT COUNT(*)
           INTO V_NRPARCELA
           FROM RATEIONF
          WHERE CDFILIAL = P_CDFILIAL
            AND NRLANCTONF = P_NRLANCTONF;
         V_VRPARCELA := 0;
         V_VRACUMULADO := 0;
         V_COUNT := 0;
         IF V_NRPARCELA > 0 THEN
            FOR C_RATEIO IN (SELECT RT.CDFILIAL, RT.NRLANCTONF, RT.CDFILICCUST, RT.CDCENTCUSNF, ((SUM(RT.VRRATENF) * 100) / DECODE(VRTOTAL, 0, 1, VRTOTAL))  AS VRPERCENTUAL
                               FROM RATEIONF RT, (SELECT SUM(VRRATENF) AS VRTOTAL
                                                    FROM RATEIONF
                                                   WHERE CDFILIAL = P_CDFILIAL
                                                     AND NRLANCTONF = P_NRLANCTONF
                                                     AND ((NVL(CDTPCTPAGAR,C_CTPAG.CDTPCTPAGAR) = C_CTPAG.CDTPCTPAGAR) OR V_TIPOCTDIFE = 'S'))
                              WHERE RT.CDFILIAL = P_CDFILIAL
                                AND RT.NRLANCTONF = P_NRLANCTONF
                                AND ((NVL(RT.CDTPCTPAGAR,C_CTPAG.CDTPCTPAGAR) = C_CTPAG.CDTPCTPAGAR) OR V_TIPOCTDIFE = 'S')
                             GROUP BY RT.CDFILIAL, RT.NRLANCTONF, RT.CDFILICCUST, RT.CDCENTCUSNF, VRTOTAL) LOOP
               V_VRPARCELA := ROUND(((C_CTPAG.VRATUAPAG * C_RATEIO.VRPERCENTUAL) / 100), 2);
               V_VRACUMULADO := ROUND(V_VRACUMULADO + V_VRPARCELA, 2);
               INSERT INTO RATCTPAGAR
                  (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG,
                   CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG)
               VALUES
                  (C_CTPAG.CDFILIAL, C_CTPAG.NRLANCTONF, C_CTPAG.NRSEQVENPAG, C_CTPAG.NRPARCELAPAG,
                   C_RATEIO.CDCENTCUSNF, C_RATEIO.CDFILICCUST, V_VRPARCELA);

               V_RATEIO_CDCENTCUSNF := C_RATEIO.CDCENTCUSNF;
               V_RATEIO_CDFILICCUST := C_RATEIO.CDFILICCUST;
            END LOOP;
            IF V_VRACUMULADO <> C_CTPAG.VRATUAPAG THEN
               V_VRACUMULADO := C_CTPAG.VRATUAPAG - V_VRACUMULADO;
               UPDATE RATCTPAGAR
                  SET VRRATCCCTPAG = VRRATCCCTPAG + V_VRACUMULADO
                WHERE CDFILIAL = C_CTPAG.CDFILIAL
                  AND NRLANCTONF = C_CTPAG.NRLANCTONF
                  AND NRSEQVENPAG = C_CTPAG.NRSEQVENPAG
                  AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                  AND CDCENTCUST = V_RATEIO_CDCENTCUSNF
                  AND CDFIRATCTPAG = V_RATEIO_CDFILICCUST;
            END IF;
         ELSE
            V_RATPROD := 'N';
            /*BUSCA OS PRODUTOS DA NOTA FISCAL*/
            FOR C_PROD_CONTA IN (SELECT P3.CDPRODUTO, P4.CDARVPROD, P4.CDRATEIO,
                                        ROUND(I.VRBRUTITEM,2) AS VRBRUTITEM
                                   FROM ITEMPRODUTO I, PRODUTO P3, PRODUTO P4
                                  WHERE I.CDFILIAL   =   C_CTPAG.CDFILIAL
                                    AND I.NRLANCTONF = C_CTPAG.NRLANCTONF
                                    AND I.CDPRODUTO = P3.CDPRODUTO
                                    AND (INSTR(P3.CDARVPROD,NVL(RTRIM(P4.CDARVPROD),P3.CDARVPROD)) = 1)
                                    AND P4.CDARVPROD = (SELECT MAX(P1.CDARVPROD)
                                                          FROM ITEMPRODUTO IT,  PRODUTO P, PRODUTO P1
                                                         WHERE IT.CDFILIAL = I.CDFILIAL
                                                           AND IT.NRLANCTONF = I.NRLANCTONF
                                                           AND IT.CDPRODUTO = I.CDPRODUTO
                                                           AND IT.CDPRODUTO = P.CDPRODUTO
                                                           AND (INSTR(P.CDARVPROD,NVL(RTRIM(P1.CDARVPROD),P.CDARVPROD)) = 1))) LOOP
               IF C_PROD_CONTA.CDRATEIO IS NOT NULL THEN
                  /*BUSCA PADRAO DE RATEIO DO PRODUTO*/
                  FOR C_PADRAT IN (SELECT CDFILIAL AS CDFILICCUST, CDCENTCUST AS CDCENTCUSNF, (VRRATEIO/100) AS VRRATEIO
                                     FROM ITEMRATEIO
                                    WHERE CDRATEIO = C_PROD_CONTA.CDRATEIO) LOOP
                     V_RATPROD := 'S';
                     V_VRPARCELA := ROUND((C_PROD_CONTA.VRBRUTITEM * C_PADRAT.VRRATEIO),2);
                     V_VRACUMULADO := V_VRACUMULADO + V_VRPARCELA;
                     BEGIN
                        SELECT CDFILIAL
                          INTO V_CDFILIRAT
                          FROM RATCTPAGAR
                         WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                           AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                           AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                           AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                           AND CDCENTCUST  = C_PADRAT.CDCENTCUSNF
                           AND CDFIRATCTPAG = C_PADRAT.CDFILICCUST;
                     EXCEPTION WHEN NO_DATA_FOUND THEN
                           V_CDFILIRAT := NULL;
                     END;
                     IF V_CDFILIRAT IS NULL THEN
                        INSERT INTO RATCTPAGAR
                            (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG,
                             CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG)
                         VALUES
                            (C_CTPAG.CDFILIAL, C_CTPAG.NRLANCTONF, C_CTPAG.NRSEQVENPAG, C_CTPAG.NRPARCELAPAG,
                             C_PADRAT.CDCENTCUSNF, C_PADRAT.CDFILICCUST, V_VRPARCELA);

                        V_RATEIO_CDCENTCUSNF := C_PADRAT.CDCENTCUSNF;
                        V_RATEIO_CDFILICCUST := C_PADRAT.CDFILICCUST;
                     ELSE
                         UPDATE  RATCTPAGAR
                            SET  VRRATCCCTPAG = VRRATCCCTPAG +  V_VRPARCELA
                          WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                            AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                            AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                            AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                            AND CDCENTCUST  = C_PADRAT.CDCENTCUSNF
                            AND CDFIRATCTPAG = C_PADRAT.CDFILICCUST;
                     END IF;
                  END LOOP;
               ELSE
                  /*BUSCA O CENTRO DE CUSTO DA FILIAL. SE NO PARAMETRIZADO, PEGA O DA EMPRESA*/
                  BEGIN
                     SELECT MAX(CDFILIAL) AS CDFILIAL, MAX(CDCENTCUST) AS CDCENTCUST
                       INTO V_CDFILIAL, V_CDCENTCUST
                       FROM
                       (SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                         FROM FILIAL F, EMPRESA E
                        WHERE F.CDFILIAL   = P_CDFILIORIG AND
                              E.CDEMPRESA  = P_CDEMPRESA  AND
                              F.CDEMPRESA  = E.CDEMPRESA
                        UNION
                       SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                         FROM FILIAL F, EMPRESA E, EMPRCNTRFIL EC
                        WHERE EC.CDFILIAL   = P_CDFILIORIG AND
                              EC.CDEMPRESA  = P_CDEMPRESA  AND
                              E.CDEMPRESA   = EC.CDEMPRESA AND
                              F.CDFILIAL = EC.CDFILIAL);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDFILIAL := NULL;
                        V_CDCENTCUST := NULL;
                  END;
                  V_VRPARCELA := C_PROD_CONTA.VRBRUTITEM;
                  V_VRACUMULADO := ROUND(V_VRACUMULADO + V_VRPARCELA, 2);
                  IF NOT (V_CDFILIAL IS NULL) AND NOT (V_CDCENTCUST IS NULL) THEN
                        BEGIN
                           SELECT CDFILIAL
                             INTO V_CDFILIRAT
                             FROM RATCTPAGAR
                            WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                              AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                              AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                              AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                              AND CDCENTCUST   = V_CDCENTCUST
                              AND CDFIRATCTPAG = V_CDFILIAL;
                        EXCEPTION WHEN NO_DATA_FOUND THEN
                              V_CDFILIRAT := NULL;
                        END;
                        IF V_CDFILIRAT IS NULL THEN
                           INSERT INTO RATCTPAGAR
                               (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG,
                                CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG)
                            VALUES
                               (C_CTPAG.CDFILIAL, C_CTPAG.NRLANCTONF, C_CTPAG.NRSEQVENPAG, C_CTPAG.NRPARCELAPAG,
                                V_CDCENTCUST, V_CDFILIAL, V_VRPARCELA);

                           V_RATEIO_CDCENTCUSNF := V_CDCENTCUST;
                           V_RATEIO_CDFILICCUST := V_CDFILIAL;
                        ELSE
                            UPDATE  RATCTPAGAR
                               SET  VRRATCCCTPAG = VRRATCCCTPAG +  V_VRPARCELA
                             WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                               AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                               AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                               AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                               AND CDCENTCUST   = V_CDCENTCUST
                               AND CDFIRATCTPAG = V_CDFILIAL;
                        END IF;

                  END IF;
               END IF;
            END LOOP;
            SELECT COUNT(*)
              INTO V_NRPARCELA
              FROM RATTPCTP
             WHERE CDTPCTPAGAR = C_CTPAG.CDTPCTPAGAR;
            IF (V_NRPARCELA = 0 AND V_RATPROD = 'N' )THEN
               FOR C_RATTPCTP IN (SELECT CDTPCTPAGAR, CDCENTCUST,
                                         DECODE(CDFIRATTPCTP,'----', P_CDFILIORIG, CDFIRATTPCTP) AS CDFIRATTPCTP,
                                         CDFILIAL, (VRPERATTPCTP/100) AS VRPERATTPCTP
                                    FROM RATTPCTP
                                   WHERE CDTPCTPAGAR = C_CTPAG.CDTPCTPAGAR) LOOP
                  V_VRPARCELA := ROUND((C_CTPAG.VRATUAPAG * C_RATTPCTP.VRPERATTPCTP),2);
                  V_VRACUMULADO := V_VRACUMULADO + V_VRPARCELA;
                  IF V_COUNT = V_NRPARCELA  THEN
                     V_VRPARCELA := V_VRPARCELA + ROUND(C_CTPAG.VRATUAPAG - V_VRACUMULADO,2);
                  END IF;
                  IF NOT (C_RATTPCTP.CDFIRATTPCTP IS NULL) AND NOT (C_RATTPCTP.CDCENTCUST IS NULL) THEN
                     /*INSERE RATEIO PARA A CONTA A PAGAR*/
                     INSERT INTO RATCTPAGAR
                        (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG,
                         CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG)
                     VALUES
                        (C_CTPAG.CDFILIAL, C_CTPAG.NRLANCTONF, C_CTPAG.NRSEQVENPAG, C_CTPAG.NRPARCELAPAG,
                         C_RATTPCTP.CDCENTCUST, C_RATTPCTP.CDFIRATTPCTP, V_VRPARCELA);
                  END IF;
                  V_COUNT := V_COUNT + 1;
               END LOOP;
            ELSE
               IF V_RATPROD = 'N' THEN
                  /*BUSCA O CENTRO DE CUSTO DA FILIAL. SE NO PARAMETRIZADO, PEGA O DA EMPRESA*/
                  BEGIN
                     SELECT MAX(CDFILIAL) AS CDFILIAL, MAX(CDCENTCUST) AS CDCENTCUST
                       INTO V_CDFILIAL, V_CDCENTCUST
                       FROM
                       (SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                         FROM FILIAL F, EMPRESA E
                        WHERE F.CDFILIAL   = P_CDFILIORIG AND
                              E.CDEMPRESA  = P_CDEMPRESA  AND
                              F.CDEMPRESA  = E.CDEMPRESA
                        UNION
                       SELECT F.CDFILIAL, NVL(F.CDCENTCUST, E.CDCENTCUST) AS CDCENTCUST
                         FROM FILIAL F, EMPRESA E, EMPRCNTRFIL EC
                        WHERE EC.CDFILIAL   = P_CDFILIORIG AND
                              EC.CDEMPRESA  = P_CDEMPRESA  AND
                              E.CDEMPRESA   = EC.CDEMPRESA AND
                              F.CDFILIAL = EC.CDFILIAL);
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDFILIAL := NULL;
                        V_CDCENTCUST := NULL;
                  END;
                  V_VRPARCELA := C_CTPAG.VRATUAPAG;
                  IF NOT (V_CDFILIAL IS NULL) AND NOT (V_CDCENTCUST IS NULL) THEN
                        BEGIN
                           SELECT CDFILIAL
                             INTO V_CDFILIRAT
                             FROM RATCTPAGAR
                            WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                              AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                              AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                              AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                              AND CDCENTCUST   = V_CDCENTCUST
                              AND CDFIRATCTPAG = V_CDFILIAL;
                        EXCEPTION WHEN NO_DATA_FOUND THEN
                              V_CDFILIRAT := NULL;
                        END;
                        IF V_CDFILIRAT IS NULL THEN
                           /*INSERE RATEIO DA CONTA A PAGAR*/
                           INSERT INTO RATCTPAGAR
                                (CDFILIAL, NRLANCTONF, NRSEQVENPAG, NRPARCELAPAG,
                                 CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG)
                             VALUES
                                (C_CTPAG.CDFILIAL, C_CTPAG.NRLANCTONF, C_CTPAG.NRSEQVENPAG, C_CTPAG.NRPARCELAPAG,
                                V_CDCENTCUST, V_CDFILIAL, V_VRPARCELA);

                           V_RATEIO_CDCENTCUSNF := V_CDCENTCUST;
                           V_RATEIO_CDFILICCUST := V_CDFILIAL;
                        ELSE
                            UPDATE  RATCTPAGAR
                               SET  VRRATCCCTPAG = VRRATCCCTPAG +  V_VRPARCELA
                             WHERE CDFILIAL     = C_CTPAG.CDFILIAL
                               AND NRLANCTONF   = C_CTPAG.NRLANCTONF
                               AND NRSEQVENPAG  = C_CTPAG.NRSEQVENPAG
                               AND NRPARCELAPAG = C_CTPAG.NRPARCELAPAG
                               AND CDCENTCUST   = V_CDCENTCUST
                               AND CDFIRATCTPAG = V_CDFILIAL;
                        END IF;

                  END IF;
               END IF;
            END IF;
         END IF;
     END LOOP;
   END;	  

BEGIN

   SELECT DECODE(P_IDENTRSAID, 'E', CDFILIRECE, CDFILIEMIT), IDSISTEMA, CDEMPRESA
     INTO V_CDFILIAL, V_IDSISTEMA, V_CDEMPRESA
     FROM NOTAFISCAL
    WHERE CDFILIAL   = P_CDFILIAL
      AND NRLANCTONF = P_LANCAMENTO;
   V_CDFILIAL := NVL(P_CDFILIRAT,V_CDFILIAL);
   
   IF V_IDSISTEMA = 'TMP' THEN
   
      SELECT MAX(CDCENTCUST)
      INTO V_CDCENTCUST
      FROM FILIAL
      WHERE CDFILIAL = V_CDFILIAL;

      IF P_IDENTRSAID = 'E' THEN
         /* Para a entrada gera rateio de Contas a pagar*/
         SELECT COUNT(*)
         INTO V_RATTPCT
         FROM  RATTPCTP
         WHERE CDTPCTPAGAR = P_CDTIPOCONTA;

         IF V_RATTPCT > 0 THEN
            FOR C_RATTPCT IN C_RATTPCTPAG LOOP
               V_VALORRAT := (P_VRCONTA * C_RATTPCT.VRPERATTPCTP)/100;
               IF C_RATTPCT.CDFILIAL IS NULL THEN
                   V_CDFILIAL := V_CDFILIAL;
               ELSE
                   V_CDFILIAL := C_RATTPCT.CDFIRATTPCTP;
               END IF;
               INSERT INTO RATCTPAGAR
                  (CDFILIAL, NRLANCTONF, NRSEQVENPAG,
                   NRPARCELAPAG, CDCENTCUST, CDFIRATCTPAG,
                   VRRATCCCTPAG)
               VALUES
                  (P_CDFILIAL, P_LANCAMENTO, P_NRSEQVENC,
                   P_NRPARCELA, C_RATTPCT.CDCENTCUST, V_CDFILIAL,
                   V_VALORRAT);
            END LOOP;
         ELSE
            IF V_CDCENTCUST IS NOT NULL THEN
               INSERT INTO RATCTPAGAR
                  (CDFILIAL, NRLANCTONF, NRSEQVENPAG,
                   NRPARCELAPAG, CDCENTCUST, CDFIRATCTPAG,
                   VRRATCCCTPAG)
               VALUES
                  (P_CDFILIAL, P_LANCAMENTO, P_NRSEQVENC,
                   P_NRPARCELA, V_CDCENTCUST, V_CDFILIAL,
                   P_VRCONTA);
             END IF;
         END IF;
      ELSE
         /* Para a entrada gera rateio de Contas a Receber*/
         SELECT COUNT(*)
         INTO V_RATTPCT
         FROM  RATTPCTR
         WHERE CDTPCTRECEB = P_CDTIPOCONTA;

         IF V_RATTPCT > 0 THEN
            FOR C_RATTPCT IN C_RATTPCTREC LOOP
               V_VALORRAT := (P_VRCONTA * C_RATTPCT.VRPERATTPCTR)/100;
               IF C_RATTPCT.CDFILIAL IS NULL THEN
                   V_CDFILIAL := P_CDFILIRAT;
               ELSE
                   V_CDFILIAL := C_RATTPCT.CDFIRATTPCTR;
               END IF;
               --raise_application_error(-20501, P_CDFILIRAT, True);
               INSERT INTO RATCTRECEBER
                  (CDFILIAL, NRLANCTONF, NRSEQVENREC,
                   NRPARCELAREC, CDCENTCUST, CDFIRATCTREC,
                   VRRATCCCTREC)
               VALUES
                  (P_CDFILIAL, P_LANCAMENTO, P_NRSEQVENC,
                   P_NRPARCELA, C_RATTPCT.CDCENTCUST, V_CDFILIAL,
                   V_VALORRAT);

            END LOOP;
         ELSE
            IF V_CDCENTCUST IS NOT NULL THEN
               INSERT INTO RATCTRECEBER
                  (CDFILIAL, NRLANCTONF, NRSEQVENREC,
                   NRPARCELAREC, CDCENTCUST, CDFIRATCTREC,
                   VRRATCCCTREC)
               VALUES
                  (P_CDFILIAL, P_LANCAMENTO, P_NRSEQVENC,
                   P_NRPARCELA, V_CDCENTCUST, P_CDFILIRAT,
                   P_VRCONTA);
             END IF;
         END IF;
      END IF;
   ELSE
      GERA_RATEIO_PAG(V_CDEMPRESA,
                      P_CDFILIRAT,
                      P_CDFILIAL,
                      P_LANCAMENTO);
   END IF;
END;
/